// Generated by CoffeeScript 1.6.1
(function() {
  var TreeList, TreeList2, TreeListBase,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  TreeListBase = (function() {

    function TreeListBase(containerNode, dataSource) {
      var self;
      this.containerNode = containerNode;
      this.dataSource = dataSource != null ? dataSource : null;
      this.editingItem = null;
      $(this.containerNode).addClass("treeList");
      $(this.containerNode).on("mouseenter", "li div", function(event) {
        if ($(this) !== this.editingItem) {
          return $(this).addClass('treeListItemOver');
        }
      });
      $(this.containerNode).on("mouseleave", "li div", function(event) {
        if ($(this) !== this.editingItem) {
          return $(this).removeClass('treeListItemOver');
        }
      });
      this.treeNodes = {};
      self = this;
      $(this.containerNode).on("click", "li i.icon-circle-arrow-right", function(event) {
        var name;
        event.stopImmediatePropagation();
        $(this).addClass('icon-circle-arrow-down').removeClass('icon-circle-arrow-right');
        name = $(this).parent().parent().attr("id");
        $("#" + name).append(self.treeNodes[name]);
        delete self.treeNodes[name];
        if (self.editingItem) {
          return $("" + self.containerNode + " span.update, " + self.containerNode + " span.delete").hide();
        } else {
          return $("" + self.containerNode + " span.update, " + self.containerNode + " span.delete").show();
        }
      });
      $(this.containerNode).on("click", "li i.icon-circle-arrow-down", function(event) {
        var name;
        event.stopImmediatePropagation();
        $(this).addClass('icon-circle-arrow-right').removeClass('icon-circle-arrow-down');
        name = $(this).parent().parent().attr("id");
        return self.treeNodes[name] = $(this).parent().next().detach();
      });
    }

    TreeListBase.prototype.show = function(dataSource) {
      var name, ul, _, _ref, _results;
      this.dataSource = dataSource;
      $(this.containerNode).empty();
      this.renderTree(this.containerNode, this.getDepartTreeData());
      _ref = this.treeNodes;
      _results = [];
      for (name in _ref) {
        _ = _ref[name];
        ul = $("#" + name).find("ul:first");
        ul.prev().find("i:first").addClass('icon-plus-sign').removeClass('icon-minus-sign');
        _results.push(this.treeNodes[name] = ul.detach());
      }
      return _results;
    };

    TreeListBase.prototype.showEditingItem = function() {
      if (!this.editingItem) {
        return;
      }
      this.editingItem.parent().removeClass('treeListItemSelected');
      $("" + this.containerNode + " span.update, " + this.containerNode + " span.delete").show();
      return this.editingItem = null;
    };

    TreeListBase.prototype.getEditingItemId = function() {
      if (!this.editingItem) {
        return null;
      }
      return this.editingItem.parent().attr('id');
    };

    TreeListBase.prototype.renderTree = function(node, data) {
      throw new Error("renderTree method must implement in child class.");
    };

    TreeListBase.prototype.getDepartTreeData = function() {
      var departs, findChidren, node, rootnode, treeData, value, _i, _j, _len, _len1;
      departs = this.dataSource;
      treeData = [];
      for (_i = 0, _len = departs.length; _i < _len; _i++) {
        value = departs[_i];
        rootnode = {
          label: value.name,
          id: value.id
        };
        if (!value.pid) {
          treeData.push(rootnode);
        }
      }
      findChidren = function(node, departs) {
        var childNode, _j, _len1, _results;
        _results = [];
        for (_j = 0, _len1 = departs.length; _j < _len1; _j++) {
          value = departs[_j];
          if (value.pid === node.id) {
            if (!node.children) {
              node.children = [];
            }
            childNode = {
              label: value.name,
              id: value.id
            };
            node.children.push(childNode);
            _results.push(findChidren(childNode, departs));
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      };
      for (_j = 0, _len1 = treeData.length; _j < _len1; _j++) {
        node = treeData[_j];
        findChidren(node, departs);
      }
      return treeData;
    };

    return TreeListBase;

  })();

  TreeList = (function(_super) {

    __extends(TreeList, _super);

    function TreeList(containerNode, dataSource) {
      var _this = this;
      this.containerNode = containerNode;
      this.dataSource = dataSource != null ? dataSource : null;
      TreeList.__super__.constructor.call(this, this.containerNode, this.dataSource = null);
      this.iconName = "book";
      $(this.containerNode).on("click", "span.update", function(event) {
        var t, updateEvent;
        t = $(event.target);
        t.parent().removeClass('treeListItemOver').addClass('treeListItemSelected');
        $("" + _this.containerNode + " span.update, " + _this.containerNode + " span.delete").hide();
        if (_this.editingItem) {
          _this.editingItem.parent().removeClass('treeListItemSelected');
        }
        _this.editingItem = t;
        updateEvent = jQuery.Event("update");
        updateEvent["itemId"] = t.parent().attr('id');
        return $(_this.containerNode).trigger(updateEvent);
      });
      $(this.containerNode).on("click", "span.delete", function(event) {
        var deleteEvent, t;
        t = $(event.target);
        deleteEvent = jQuery.Event("delete");
        deleteEvent["itemId"] = t.parent().attr('id');
        return $(_this.containerNode).trigger(deleteEvent);
      });
    }

    TreeList.prototype.show = function(dataSource, iconName) {
      this.dataSource = dataSource;
      this.iconName = iconName;
      console.log(this.iconName);
      return TreeList.__super__.show.call(this, this.dataSource);
    };

    TreeList.prototype.renderTree = function(node, data) {
      var linode, newnode, newnode2, value, _i, _len;
      $(node).append("<ul></ul>");
      newnode = "" + node + " ul:first";
      for (_i = 0, _len = data.length; _i < _len; _i++) {
        value = data[_i];
        linode = "<li id='" + value.id + "node'><div id='" + value.id + "'><i class='icon-" + this.iconName + "' /><span class='nodename'>" + value.label + "</span><span class='delete btn btn-danger'>删除</span><span class='update btn btn-warning'>编辑</span></div></li>";
        if (value.children) {
          linode = "<li id='" + value.id + "node'><div id='" + value.id + "'><i class='icon-circle-arrow-down' /><i class='icon-" + this.iconName + "' /><span class='nodename'>" + value.label + "</span><span class='delete btn btn-danger'>删除</span><span class='update btn btn-warning'>编辑</span></div></li>";
        }
        $(newnode).append(linode);
        newnode2 = "" + newnode + " #" + value.id + "node";
        if (value.children) {
          this.renderTree(newnode2, value.children);
        }
      }
      return null;
    };

    return TreeList;

  })(TreeListBase);

  window.TreeList = TreeList;

  TreeList2 = (function(_super) {

    __extends(TreeList2, _super);

    function TreeList2(containerNode, dataSource) {
      var _this = this;
      this.containerNode = containerNode;
      this.dataSource = dataSource != null ? dataSource : null;
      TreeList2.__super__.constructor.call(this, this.containerNode, this.dataSource = null);
      $(this.containerNode).on("click", "span.review", function(event) {
        var t, updateEvent;
        t = $(event.target);
        t.parent().removeClass('treeListItemOver').addClass('treeListItemSelected');
        if (_this.editingItem) {
          _this.editingItem.parent().removeClass('treeListItemSelected');
          _this.editingItem.show();
        }
        _this.editingItem = t;
        updateEvent = jQuery.Event("review");
        updateEvent["itemId"] = t.parent().attr('id');
        return $(_this.containerNode).trigger(updateEvent);
      });
    }

    TreeList2.prototype.renderTree = function(node, data) {
      var linode, newnode, newnode2, value, _i, _len, _ref;
      $(node).append("<ul></ul>");
      newnode = "" + node + " ul:first";
      for (_i = 0, _len = data.length; _i < _len; _i++) {
        value = data[_i];
        if ((_ref = value.node) == null) {
          value.node = 0;
        }
        linode = "<li id='" + value.id + "node" + value.node + "'><div id='" + value.id + "' class='page'><i class='icon-user'></i><span class='nodename'>" + value.label + "</span><span class='review btn btn-warning'>查看</span></div></div></li>";
        if (value.node === 1) {
          linode = "<li id='" + value.id + "node" + value.node + "'><div id='" + value.id + "' class='node'><i class='icon-circle-arrow-down' /><i class='icon-book'></i><span class='nodename'>" + value.label + "</span></div></div></li>";
        }
        $(newnode).append(linode);
        newnode2 = "" + newnode + " #" + value.id + "node" + value.node;
        if (value.children) {
          this.renderTree(newnode2, value.children);
        }
      }
      return null;
    };

    return TreeList2;

  })(TreeListBase);

  window.TreeList2 = TreeList2;

}).call(this);
