// Generated by CoffeeScript 1.6.1
(function() {
  var WriteReportViewModel, editor, init, validator;

  validator = new Validator();

  editor = UE.getEditor('content');

  WriteReportViewModel = function() {
    var self;
    self = this;
    self.dateTxt = ko.observable(null);
    self.validDateTxt = ko.computed(function() {
      var date, dateStr, months, year, _ref;
      dateStr = $.trim(self.dateTxt());
      try {
        validator.check(dateStr).notEmpty();
        _ref = dateStr.split("-"), year = _ref[0], months = _ref[1], date = _ref[2];
        validator.check(year).notNull().isNumeric().len(4, 4);
        validator.check(months).notNull().isNumeric().len(1, 2);
        validator.check(date).notNull().isNumeric().len(1, 2);
        return true;
      } catch (error) {
        return false;
      }
    });
    return self;
  };

  init = function() {
    var dateStr, getDateStr, reportvm;
    $("#dateTxt").datepicker();
    $("#dateTxt").datepicker("option", "dateFormat", "yy-mm-dd");
    reportvm = new WriteReportViewModel();
    ko.applyBindings(reportvm);
    getDateStr = function(date) {
      var month, today, year;
      today = new Date();
      year = date.getFullYear();
      month = date.getMonth() + 1;
      date = date.getDate();
      return "" + year + "-" + month + "-" + date;
    };
    dateStr = getDateStr(new Date());
    reportvm.dateTxt(dateStr);
    return $("#reportSubmitBtn").click(function(event) {
      var data;
      if (!reportvm.validDateTxt()) {
        return;
      }
      dateStr = getDateStr($("#dateTxt").datepicker("getDate"));
      data = {
        date: dateStr,
        content: editor.getContent()
      };
      return ReportModel.createReport(data, function(response) {
        if (response.state === 0) {
          return;
        }
        return window.location.href = "/show";
      });
    });
  };

  init();

}).call(this);
